//+------------------------------------------------------------------+
//|                                               largetimeframe.mq5 |
//|                        Copyright 2011, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//|     .                 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2011, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property indicator_chart_window
#include <Indicators\TimeSeries.mqh>
//--- input parameters
input ENUM_TIMEFRAMES Timeframe=PERIOD_D1;
input int      CountBars=10;
input color    Bear=clrMaroon;
input color    Bull=clrMidnightBlue;
//----
   int number;
   bool first;
   datetime Time_Open[];
   double Open_Large[],Close_Large[],High_Large[],Low_Large[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
  if((int)Timeframe<=(int)_Period||PeriodSeconds(Timeframe)%PeriodSeconds()!=0)
   {
    Alert(" !!!  ,  .");
    return(-1);
   }
  Comment("LargeTimeframe: ",PeriodDescription(Timeframe));
  ArrayResize(Time_Open,Timeframe);
  ArrayResize(Open_Large,Timeframe);
  ArrayResize(Close_Large,Timeframe);
  ArrayResize(High_Large,Timeframe);
  ArrayResize(Low_Large,Timeframe);
  ArraySetAsSeries(Time_Open,true);
  ArraySetAsSeries(Open_Large,true);
  ArraySetAsSeries(Close_Large,true);
  ArraySetAsSeries(High_Large,true);
  ArraySetAsSeries(Low_Large,true);
  first=true;  
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   ObjDel();
   Comment("");
  };
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int begin=0;
   if(first)
    {
     begin=CountBars-1;
     ObjDel();
     number=0;
    }
   else
    if(!isNewBar(Timeframe))
     {
      ObjectDelete(0,"Objtf"+(string)number); 
      ObjectDelete(0,"Objtf"+string(number-1));
      number-=2;
     }    
   datetime time1;
   datetime time2;
   double open_price,close_price,high_price,low_price;
   int bar_tf;
   int i;
   datetime iTime[1];
   ResetLastError();
   if(CopyTime(_Symbol,Timeframe,0,CountBars,Time_Open)==CountBars)
    if(CopyOpen(_Symbol,Timeframe,0,CountBars,Open_Large)==CountBars)
     if(CopyClose(_Symbol,Timeframe,0,CountBars,Close_Large)==CountBars)
      if(CopyHigh(_Symbol,Timeframe,0,CountBars,High_Large)==CountBars)
       if(CopyLow(_Symbol,Timeframe,0,CountBars,Low_Large)==CountBars)    
//----
   for(bar_tf=begin;bar_tf>=0;bar_tf--)
     {
      time1=Time_Open[bar_tf]; 
      i=bar_tf-1;
      if(!CopyTime(_Symbol,PERIOD_CURRENT,0,1,iTime))
       return(rates_total);
      if (i<0)
       {time2=iTime[0];first=false;}
      else
       time2=Time_Open[i]-PeriodSeconds();
      open_price=Open_Large[bar_tf]; 
      close_price=Close_Large[bar_tf]; 
      high_price=High_Large[bar_tf];
      low_price=Low_Large[bar_tf];
//---
      ObjectCreate(0,"Objtf"+(string)number,OBJ_RECTANGLE,0,time1,open_price,time2,close_price);
      ObjectSetInteger(0,"Objtf"+(string)number, OBJPROP_BACK, true);
      ObjectSetInteger(0,"Objtf"+(string)number, OBJPROP_FILL, true);
      if (time2-time1<PeriodSeconds(Timeframe)/2)
         time2=iTime[0];
      else
         time2=time1+PeriodSeconds(Timeframe)/2;
      number++;
//----      
      ObjectCreate(0,"Objtf"+(string)number,OBJ_TREND,0,time2,high_price,time2,low_price);
      ObjectSetInteger(0,"Objtf"+(string)number, OBJPROP_WIDTH, 4);
      ObjectSetInteger(0,"Objtf"+(string)number, OBJPROP_STYLE, STYLE_SOLID);
      ObjectSetInteger(0,"Objtf"+(string)number, OBJPROP_BACK, true);
//----      
      if (close_price>open_price)
        {
         ObjectSetInteger(0,"Objtf"+(string)(number-1),OBJPROP_COLOR, Bull);
         ObjectSetInteger(0,"Objtf"+(string)number,OBJPROP_COLOR, Bull);
        }
      else
        {
         ObjectSetInteger(0,"Objtf"+(string)(number-1),OBJPROP_COLOR, Bear);
         ObjectSetInteger(0,"Objtf"+(string)number,OBJPROP_COLOR, Bear);
        }
      number++;
     }
      
//--- return value of prev_calculated for next call
   return(rates_total);
}
//+------------------------------------------------------------------+
   void ObjDel()
  {
   for(;number>=0;number--)
      ObjectDelete(0,"Objtf"+(string)number);
  }
//+------------------------------------------------------------------+
//| Converting value of ENUM_TIMEFRAMES to string.                   |
//+------------------------------------------------------------------+
string PeriodDescription(int val)
  {
   int i,frame;
//--- arrays for conversion of ENUM_TIMEFRAMES to string
   static string          _p_str[]={"M1","M2","M3","M4","M5","M6","M10","M12","M15","M20","M30",
                                    "H1","H2","H3","H4","H6","H8","H12","D1","W1","MN","UNKNOWN"};
   static ENUM_TIMEFRAMES _p_int[]={PERIOD_M1,PERIOD_M2,PERIOD_M3,PERIOD_M4,PERIOD_M5,PERIOD_M6,
                                    PERIOD_M10,PERIOD_M12,PERIOD_M15,PERIOD_M20,PERIOD_M30,
                                    PERIOD_H1,PERIOD_H2,PERIOD_H3,PERIOD_H4,PERIOD_H6,PERIOD_H8,PERIOD_H12,
                                    PERIOD_D1,PERIOD_W1,PERIOD_MN1};
//--- checking
   frame=(val==0)?_Period:val;
   if(frame==WRONG_VALUE) return("WRONG_VALUE");
//--- cycle for all timeframes
   for(i=0;i<ArraySize(_p_int);i++)
      if(frame==_p_int[i]) break;
//---
   return(_p_str[i]);
  }
//+------------------------------------------------------------------+
//|  isNewBar() function                                               |
//+------------------------------------------------------------------+
bool isNewBar(ENUM_TIMEFRAMES timeframe)
  {
//----
   bool res=false;               //     
   static datetime old_Time=0;
//       new_Time  
   datetime new_Time=(datetime)SeriesInfoInteger(_Symbol,timeframe,SERIES_LASTBAR_DATE);         //   
   if(old_Time!=new_Time) //       
     {
      if(old_Time!=0)
         res=true;              //     ,   =true
      old_Time=new_Time;        //   
     }
   return(res);
  }
//---- 
